; GUI #
;fog.c
;This program draws 5 red teapots, each at a different z distance from the eye, 
;in different types of fog. Pressing the left mouse button chooses between 3 
;types of fog: exponential, exponential squared, and linear. In this program, 
;there is a fixed density value, as well as fixed start and end values for 
;the linear fog.
include win64a.inc
; --------------- 
WINDOWWIDTH  = 600
WINDOWHEIGHT = 400

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 or \
	(sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke  TranslateMessage,edi
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	rc:RECT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_CHAR
	je      wmCHAR
	cmp	edx,WM_PAINT	
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC

	invoke	RtlExitUserProcess,NULL
wmCHAR:	mov	al,r8b;wParam
	or	al,20h
	cmp	al,'f'
	jne	wmBYE
	cmp	fogMode,GL_EXP;800h
	jne	@f
	inc	fogMode;fogMode=GL_EXP2=801h
	jmp	@0
@@:	cmp	fogMode,GL_EXP2;801h
	jne	@f
	mov	fogMode,GL_LINEAR;2601h
	jmp	@0
@@:	cmp	fogMode,GL_LINEAR
	jne	wmBYE
	mov	fogMode,GL_EXP
@0:	invoke  glFogi,GL_FOG_MODE,fogMode
	lea	edx,rc
	invoke	GetClientRect,hWin
	lea	edx,rc
	invoke	InvalidateRect,hWin,,0
	jmp	wmBYE
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;GLInit----------------------------------
	invoke  glEnable, GL_DEPTH_TEST
	mov	r8d,offset position
	invoke  glLightfv, GL_LIGHT0, GL_POSITION
	invoke  glEnable, GL_LIGHTING
	invoke  glEnable, GL_LIGHT0

	mov	r8d,offset mat
	invoke  glMaterialfv, GL_FRONT,GL_AMBIENT
	mov	eax,const0_61424
	mov     mat[0],eax
	mov	eax,const0_04136
	mov     mat[4],eax
	mov     mat[8],eax
	mov	r8d,offset mat
	invoke  glMaterialfv, GL_FRONT, GL_DIFFUSE
	mov	eax,const0_727811
	mov     mat[0],eax
	mov	eax,const0_626959
	mov     mat[4],eax
	mov     mat[8],eax
	mov	r8d,offset mat
	invoke  glMaterialfv,GL_FRONT,GL_SPECULAR
	movd	xmm2,const76_8
	invoke  glMaterialf, GL_FRONT,GL_SHININESS
	mov     fogMode,GL_EXP
	invoke  glEnable, GL_FOG
	invoke  glFogi,GL_FOG_MODE,fogMode
	mov	edx,offset fogColor
	invoke  glFogfv,GL_FOG_COLOR
	movd	xmm1,const0_35
	invoke  glFogf,GL_FOG_DENSITY
	invoke  glHint,GL_FOG_HINT,GL_DONT_CARE
	movd	xmm1,const1
	invoke  glFogf,GL_FOG_START
	movd	xmm1,const5
	invoke  glFogf,GL_FOG_END
	movd	xmm3,const1
	mov	eax,const0_5
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke  glClearColor ;fog color
;---------------------------------------------
	invoke	GLReshape, WINDOWWIDTH, WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:;     
	mov	edx,r9d
	movzx	ecx,dx
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
;;  
        invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	movd	xmm2,const_1
	movd	xmm1,const_0_5
	movd	xmm0,const_2
	invoke	renderSphere
	movd	xmm2,const_2
	movd	xmm1,const_0_5
	movd	xmm0,const_1
	invoke	renderSphere
	movd	xmm2,const_3
	movd	xmm1,const_0_5
	movd	xmm0,ebx
	invoke	renderSphere
	movd	xmm2,const_4
	movd	xmm1,const_0_5
	movd	xmm0,const1
	invoke	renderSphere
	movd	xmm2,const_5
	movd	xmm1,const_0_5
	movd	xmm0,const2
	invoke	renderSphere
	
	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
renderSphere proc 
local	x:dword
local	y:dword
local	z:dword

	movd	x,xmm0
	movd	y,xmm1
	movd	z,xmm2

	invoke  glPushMatrix
	movd	xmm0,x
	movd	xmm1,y
	movd	xmm2,z
	invoke  glTranslatef
	movq	xmm0,constd0_5
	invoke  glutSolidSphere,,16,16
	invoke  glPopMatrix
	leave
	retn
renderSphere endp
GLReshape proc w:dword,h:dword
local	resulta:QWORD
local	resultb:QWORD
	
	mov	w,ecx
	mov	h,edx
	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode,GL_PROJECTION
	invoke  glLoadIdentity

	mov     eax,h
	cmp	w,eax ;if (w <= h)
	ja	@f
	fld	constd_2_5
	fimul	h
	fidiv   w
	fstp    resulta
	fld	constd2_5
	fimul   h
	fidiv   w
	fstp    resultb
	movq	xmm3,resultb	
	movq	xmm2,resulta	
	movq	xmm1,constd2_5	
	movq	xmm0,constd_2_5
	jmp	@0
@@:	fld	constd_2_5
	fimul   w
	fidiv   h
	fstp	resulta
	fld	constd2_5
	fimul   w
	fidiv   h
	fstp    resultb
	movq	xmm3,constd2_5	
	movq	xmm2,constd_2_5
	movq	xmm1,resultb	
	movq	xmm0,resulta	
@0:	invoke  glOrtho,,,,,constd_10,constd10
	invoke	glMatrixMode,GL_MODELVIEW
        invoke  glLoadIdentity
	leave
	retn
GLReshape endp
;-----------------------------------------------------------
hDC	dq	?
hrc	dq	?;  
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "Uncle Remus tales:#40 OpenGL - Fog",0
FileName	db "br_Rabbit3.cur",0
;float
const0_35	dd 0.35
const0_04136	dd 0.04136
const_0_5	dd -0.5
const0_5	dd 0.5
const0_61424	dd 0.61424
const0_626959	dd 0.626959
const0_727811	dd 0.727811
const1		dd 1.0
const_1		dd -1.0
const2		dd 2.0
const_2		dd -2.0
const_3		dd -3.0
const_4		dd -4.0
const5		dd 5.0
const_5		dd -5.0
const76_8	dd 76.8
;double----------------------------
constd0_5	dq 0.5
constd2_5	dq 2.5
constd_2_5	dq -2.5
constd10	dq 10.0
constd_10	dq -10.0

fogMode		dq 0
position	dd 0.5, 0.5, 3.0, 0.0
mat		dd 0.1745, 0.01175, 0.01175
fogColor	dd 0.5, 0.5, 0.5, 1.0
end